

__device__ void copy_float_device_shared(float *shared, float *device, int length)
{
  {
    int i;
#ifdef PARALLEL_COPY
    for (i=threadIdx.x; i<length; i+= NB_THREADS_PER_BLOCK)
#else
    for (i=0; i<length; i++)
#endif
	shared[i] = device[i] ;
  }


#ifdef PARALLEL_COPY
  __syncthreads();
#endif
}

__device__ void copy_int_device_shared(int *shared, int *device, int length)
{
  {
    int i;
#ifdef PARALLEL_COPY
    for (i=threadIdx.x; i<length; i+= NB_THREADS_PER_BLOCK)
#else
    for (i=0; i<length; i++)
#endif
	shared[i] = device[i] ;
  }

#ifdef PARALLEL_COPY
  __syncthreads();
#endif
}


__device__ void copy_uchar_device_shared(unsigned char *shared, unsigned char *device, int length)
{
  {
    int i;
#ifdef PARALLEL_COPY
    for (i=threadIdx.x; i<length; i+= NB_THREADS_PER_BLOCK)
#else
    for (i=0; i<length; i++)
#endif
	shared[i] = device[i] ;
  }

#ifdef PARALLEL_COPY
  __syncthreads();
#endif
}


__device__ void copy_seq_device_shared(int *shared, unsigned char *device, int length)
{
  
#ifdef PAD
   int *dev = (int*) device ;
#endif

    int i;
    __syncthreads();

#ifdef PARALLEL_COPY
    for (i=threadIdx.x; i<length; i+= 
         #ifdef PAD
		 4*
         #endif
		 NB_THREADS_PER_BLOCK)
#else
    for (i=0; i<length; i++)
#endif

    {
#ifdef PAD     // not working now (10% time)
	int buf = dev[i] ;
	unsigned char *b = (unsigned char *) &buf ;
       	shared[i+0] = (int) b[0] ;
	shared[i+1] = (int) b[1] ;
	shared[i+2] = (int) b[2] ;
	shared[i+3] = (int) b[3] ;
#else
	shared[i] = device[i] ;
#endif	
    }


#ifdef PARALLEL_COPY
  __syncthreads();
#endif
}
