



__device__ float pwm_score_partial(const float* matrix, int* word, int length, float *scores, int start)
{
  float score = scores[start+1] ;

  int t;

  for (t=start; t>=0; t--)
    {
      score += matrix[ALPH_SIZE*t + word[t]] ;
      scores[t] = score ;
    }

  return score ;
}


__device__ void generate_word(int *word, long n, int length)
{
  int t;
  long nn = n  ;

  for (t=0; t<length; t++)
    {
      word[t] = nn % ALPH_SIZE ;
      nn = nn/ALPH_SIZE ;
    }
}

__device__ void generate_word_rev(int *word, long n, int length)
{
  int t;
  int nn = n  ;

  for (t=0; t<length; t++)
    {
      word[length-1-t] = 0 + nn % ALPH_SIZE ;
      nn = nn/ALPH_SIZE ;
    }
}

// Generates a new word, returns the last index where there was a change 
__device__ int inc_word(int *word)
{
  int *t = word ;
  
  while (++(*t) == ALPH_SIZE)
    *(t++) = 0 ;

  return t - word ;
}





__device__ float initialize_score (const float *matrix, float *score, const int *word, int from, int to) {

	int i;
	float sum = 0;
	for (i = 0; i < to; i++) {
		score[i] = matrix[ALPH_SIZE * i + word[i]];
		sum += score[i];
	}
	return sum;

}

__device__ float change_score (const float *matrix, float *score, const int *word, int to, float sum_score) {

	int i = to;
	float sum = sum_score;
	for (i = 0; i <= to; i++) {
		sum -= score[i];
		score[i] =  matrix[ALPH_SIZE * i + word[i]];
		sum += score[i];
	}
	return sum;
}

